osgParticle::Operator Class Referenceabstract

`#include <Operator>`

Inheritance diagram for osgParticle::Operator:

## Public Member Functions

| Operator ()
| Operator (const Operator &copy, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
virtual const char * | libraryName () const
virtual const char * | className () const
virtual bool | isSameKindAs (const osg::Object *obj) const
bool | isEnabled () const
| Get whether this operator is enabled.
void | setEnabled (bool v)
| Enable or disable this operator.
virtual void | operateParticles (ParticleSystem *ps, double dt)
virtual void | operate (Particle *P, double dt)=0
virtual void | beginOperate (Program *)
virtual void | endOperate ()
| Do something after all particles have been processed.
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~Operator ()
Operator & | operator= (const Operator &)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Additional Inherited Members

Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Detailed Description

An abstract base class used by `ModularProgram` to perform operations on particles before they are updated. To implement a new operator, derive from this class and override the `operate()` method. You should also override the `beginOperate()` method to query the calling program for the reference frame used, and initialize the right transformations if needed.

## Constructor & Destructor Documentation

## Operator() [1/2]

osgParticle::Operator::Operator | ( |  | ) |

inline

References osg::Object::Object().

Referenced by osgParticle::AccelOperator::AccelOperator(), osgParticle::AccelOperator::AccelOperator(), osgParticle::AngularAccelOperator::AngularAccelOperator(), osgParticle::AngularAccelOperator::AngularAccelOperator(), osgParticle::AngularDampingOperator::AngularDampingOperator(), osgParticle::AngularDampingOperator::AngularDampingOperator(), osgParticle::DampingOperator::DampingOperator(), osgParticle::DampingOperator::DampingOperator(), osgParticle::DomainOperator::DomainOperator(), osgParticle::DomainOperator::DomainOperator(), osgParticle::ExplosionOperator::ExplosionOperator(), osgParticle::ExplosionOperator::ExplosionOperator(), osgParticle::ForceOperator::ForceOperator(), osgParticle::ForceOperator::ForceOperator(), isSameKindAs(), Operator(), operator=(), osgParticle::OrbitOperator::OrbitOperator(), and osgParticle::OrbitOperator::OrbitOperator().

## Operator() [2/2]

osgParticle::Operator::Operator | ( | const Operator & | copy,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

inline

References osg::Object::Object(), and Operator().

## ~Operator()

virtual osgParticle::Operator::~Operator | ( |  | ) |

inline protected virtual

## Member Function Documentation

## beginOperate()

virtual void osgParticle::Operator::beginOperate | ( | Program * |  | ) |

inline virtual

Do something before processing particles via the `operate()` method. Overriding this method could be necessary to query the calling `Program` object for the current reference frame. If the reference frame is RELATIVE_RF, then your class should prepare itself to do all operations in local coordinates.

Reimplemented in osgParticle::AccelOperator, osgParticle::AngularAccelOperator, osgParticle::DomainOperator, osgParticle::ExplosionOperator, osgParticle::FluidFrictionOperator, osgParticle::ForceOperator, osgParticle::OrbitOperator, and osgParticle::SinkOperator.

## className()

virtual const char * osgParticle::Operator::className | ( |  | ) | const

inline virtual

return the name of the object's class type. Must be defined by derived classes.

Implements osg::Object.

Referenced by osgParticle::DomainOperator::ignore().

## endOperate()

virtual void osgParticle::Operator::endOperate | ( |  | ) |

inline virtual

Do something after all particles have been processed.

Reimplemented in osgParticle::DomainOperator.

## isEnabled()

bool osgParticle::Operator::isEnabled | ( |  | ) | const

inline

Get whether this operator is enabled.

Referenced by operateParticles().

## isSameKindAs()

virtual bool osgParticle::Operator::isSameKindAs | ( | const osg::Object * | obj | ) | const

inline virtual

Reimplemented from osg::Object.

References Operator().

## libraryName()

virtual const char * osgParticle::Operator::libraryName | ( |  | ) | const

inline virtual

return the name of the object's library. Must be defined by derived classes. The OpenSceneGraph convention is that the namespace of a library is the same as the library name.

Implements osg::Object.

## operate()

virtual void osgParticle::Operator::operate | ( | Particle * | P,
|  | double | dt )

pure virtual

Do something on a particle. You must override it in descendant classes. Common operations consist of modifying the particle's velocity vector. The `dt` parameter is the time elapsed from last operation.

Implemented in osgParticle::AccelOperator, osgParticle::AngularAccelOperator, osgParticle::AngularDampingOperator, osgParticle::DampingOperator, osgParticle::DomainOperator, osgParticle::ExplosionOperator, osgParticle::FluidFrictionOperator, osgParticle::ForceOperator, and osgParticle::OrbitOperator.

Referenced by operateParticles().

## operateParticles()

virtual void osgParticle::Operator::operateParticles | ( | ParticleSystem * | ps,
|  | double | dt )

inline virtual

Do something on all emitted particles. This method is called by `ModularProgram` objects to perform some operations on the particles. By default, it will call the `operate()` method for each particle. You must override it in descendant classes.

References osgParticle::ParticleSystem::getParticle(), osgParticle::Particle::isAlive(), isEnabled(), osgParticle::ParticleSystem::numParticles(), and operate().

## operator=()

Operator & osgParticle::Operator::operator= | ( | const Operator & |  | ) |

inline protected

References Operator().

## setEnabled()

void osgParticle::Operator::setEnabled | ( | bool | v | ) |

inline

Enable or disable this operator.

The documentation for this class was generated from the following file:

- Operator